<?xml version="1.0"?>
<hivemq xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
	
    <cluster>

        <enabled>true</enabled>

        <transport>
            <tcp>
                <!-- replace this IP with the IP address of your interface and the port used for TCP cluster transport.-->
                <bind-address>192.168.1.1</bind-address>
                <bind-port>7800</bind-port>
            </tcp>
        </transport>

        <discovery>
            <static>
                <node>
                    <!-- replace this IP with the IP address of your interface and the port used for TCP cluster transport.-->
                    <host>192.168.1.1</host>
                    <port>7800</port>
                </node>
                <node>
                    <!-- replace this IP with the IP address of another node and the port used for TCP cluster transport.-->
                    <host>192.168.1.2</host>
                    <port>7800</port>
                </node>
                <node>
                    <!-- replace this IP with the IP address of another node and the port used for TCP cluster transport.-->
                    <host>192.168.1.3</host>
                    <port>7801</port>
                </node>
            </static>
        </discovery>

    </cluster>
	
    <listeners>
        <tcp-listener>
            <port>1883</port>
            <bind-address>0.0.0.0</bind-address>
			<name>hivemq-mqtt-listener</name>
        </tcp-listener>
		<websocket-listener>
          <port>1884</port>
          <bind-address>0.0.0.0</bind-address>
          <path>/mqtt</path>
          <name>hivemq-websocket-listener</name>
          <subprotocols>
              <subprotocol>mqttv3.1.1</subprotocol>
              <subprotocol>mqtt</subprotocol>
          </subprotocols>
          <allow-extensions>true</allow-extensions>
      </websocket-listener>
    </listeners>
	
	<restrictions>
        <max-client-id-length>200</max-client-id-length>
        <max-topic-length>400</max-topic-length>
        <max-connections>-1</max-connections>
        <incoming-bandwidth-throttling>0</incoming-bandwidth-throttling>
        <no-connect-idle-timeout>30000</no-connect-idle-timeout>
    </restrictions>
	
    <mqtt>	
		<!-- Changing client session time to live to one hour -->
		<session-expiry>
            <max-interval>3600</max-interval>
        </session-expiry>
		
		<message-expiry>
            <max-interval>4294967296</max-interval>
        </message-expiry>
		
		<packets>
            <max-packet-size>268435460</max-packet-size>
        </packets>
		
		<receive-maximum>
		    <!-- When this value is reached the client is not allowed to send additional PUBLISH messages until the broker acknowledges existing PUBLISH messages. -->
            <server-receive-maximum>20</server-receive-maximum>
        </receive-maximum>
		
		<wildcard-subscriptions>
            <enabled>true</enabled>
        </wildcard-subscriptions>
		
		<shared-subscriptions>
            <enabled>true</enabled>
        </shared-subscriptions>
		
	    <queued-messages>
		    <!-- Limit the maximum queued messages (when the client is offline or is slow consumer) per client to 10000 -->
            <max-queue-size>10000</max-queue-size>
            <strategy>discard-oldest</strategy>
        </queued-messages>
		
    </mqtt>
	
    <security>
	
        <!-- Does not allow the use of empty client ids -->
        <allow-empty-client-id>
            <enabled>false</enabled>
        </allow-empty-client-id>
		
		<!-- Enables validation for UTF-8 PUBLISH payloads -->
        <payload-format-validation>
            <enabled>true</enabled>
        </payload-format-validation>
		
		<!-- Enables the UTF-8 validation of topic names and client ids -->
        <utf8-validation>
            <enabled>true</enabled>
        </utf8-validation>
		
		<!-- Allows clients to request problem information -->
        <allow-request-problem-information>
            <enabled>true</enabled>
        </allow-request-problem-information>
		
		<!-- Enables audit logging for the control center -->
        <control-center-audit-log>
            <enabled>true</enabled>
        </control-center-audit-log>
		
    </security>

</hivemq>